Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/oasis.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/oasis.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/oasis.F90	(revision 4727)
@@ -24,7 +24,4 @@
   USE mod_prism_get_proto
   USE mod_prism_put_proto
-#endif
-#ifdef CPP_CPLOCNINCA
-  USE incaoasis, ONLY : inforcv
 #endif
 #endif
@@ -77,14 +74,13 @@
   INTEGER, PARAMETER :: idr_curenz = 7
   INTEGER, PARAMETER :: idr_oceco2 = 8
-
+  ! bulk salinity of the surface layer of the ocean, in ppt
   INTEGER, PARAMETER :: idr_sss = 9
-  ! bulk salinity of the surface layer of the ocean, in ppt
-
-  INTEGER, PARAMETER :: maxrecv    = 9  ! Maximum number of fields to receive
-  
-#ifdef CPP_CPLOCNINCA
-  INTEGER, PARAMETER :: idr_ocedms = 1
-  INTEGER, PARAMETER :: maxrcv = 1
-#endif
+  INTEGER, PARAMETER :: idr_ocedms = 10
+
+  INTEGER, PARAMETER :: maxrecv      = 10     ! Maximum number of fields to receive
+  INTEGER, PARAMETER :: maxrecv_phys = 9      ! Maximum number of fields to receive in physiq (without fields received in INCA model )
+                                              ! will be changed in next version - INCA fields will be received in LMDZ (like for ORCHIDEE fields)
+                                              ! and then send by routine in INCA model 
+  
 
   TYPE, PUBLIC ::   FLD_CPL            ! Type for coupling field information
@@ -117,8 +113,7 @@
     USE surface_data, ONLY : version_ocean
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl
-#ifdef CPP_XIOS
     USE wxios, ONLY : wxios_context_init 
-    USE xios  
-#endif
+    USE chemistry_cycle_mod, ONLY : dms_cycle_cpl
+    USE lmdz_xios  
     USE print_control_mod, ONLY: lunout
     USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, grid_type, unstructured, regular_lonlat
@@ -141,4 +136,5 @@
     CHARACTER (len = 80)               :: abort_message 
     LOGICAL, SAVE                      :: cpl_current_omp
+    INTEGER, DIMENSION(klon_mpi)       :: ind_cell_glo_mpi
 
 !*    1. Initializations
@@ -175,4 +171,9 @@
     cpl_current = cpl_current_omp
     WRITE(lunout,*) 'Couple ocean currents, cpl_current = ',cpl_current 
+
+!************************************************************************************
+! Gather global index to be used for oasis decomposition
+!************************************************************************************
+    CALL gather_omp(ind_cell_glo,ind_cell_glo_mpi)
 
 !************************************************************************************
@@ -261,7 +262,8 @@
        inforecv(idr_oceco2)%action = .TRUE. ; inforecv(idr_oceco2)%name = 'SICO2FLX'
    ENDIF
-#ifdef CPP_CPLOCNINCA
-       inforcv(idr_ocedms)%action = .TRUE. ; inforcv(idr_ocedms)%name = 'SIDMSFLX'
-#endif
+   IF (dms_cycle_cpl) THEN 
+      inforecv(idr_ocedms)%action = .TRUE. ; inforecv(idr_ocedms)%name = 'SIDMSFLX'
+   ENDIF
+ 
 
 !************************************************************************************
@@ -291,5 +293,5 @@
 
       DO jf=1, klon_mpi_para_nb(mpi_rank)
-        ig_paral(2+jf) = ind_cell_glo(jf)
+        ig_paral(2+jf) = ind_cell_glo_mpi(jf)
       ENDDO
 
@@ -349,19 +351,9 @@
     END DO
 
-! Now, if also coupling CPL with INCA, initialize here fields to be exchanged.
-#ifdef CPP_CPLOCNINCA
-    DO jf=1,maxrcv 
-       IF (inforcv(jf)%action) THEN
-          CALL prism_def_var_proto(inforcv(jf)%nid, inforcv(jf)%name, il_part_id, &
-               il_var_nodims, PRISM_In, il_var_actual_shape, il_var_type, &
-               ierror)
-          IF (ierror .NE. PRISM_Ok) THEN
-             WRITE(lunout,*) 'inicma : Problem with prism_def_var_proto for field : ',&
-                  inforcv(jf)%name
-             abort_message=' Problem in call to prism_def_var_proto for fields to receive'
-             CALL abort_physic(modname,abort_message,1)
-          ENDIF
-       ENDIF
-    END DO
+
+#ifdef INCA
+    IF (dms_cycle_cpl) THEN
+       CALL init_inca_oasis(inforecv(idr_ocedms))
+    ENDIF
 #endif
  
@@ -387,7 +379,7 @@
 ! End definition
 !************************************************************************************
-#ifdef CPP_XIOS
-    CALL xios_oasis_enddef()
-#endif
+
+    IF (using_xios) CALL xios_oasis_enddef()
+
     CALL prism_enddef_proto(ierror)
     IF (ierror .NE. PRISM_Ok) THEN
@@ -398,8 +390,4 @@
     ENDIF
 
-#ifdef CPP_XIOS
-!    CALL wxios_context_init()
-#endif
-
 !$OMP END MASTER
     
@@ -424,5 +412,5 @@
 ! Output arguments
 !************************************************************************************
-    REAL, DIMENSION(nbp_lon, jj_nb,maxrecv), INTENT(OUT) :: tab_get
+    REAL, DIMENSION(nbp_lon, jj_nb,maxrecv_phys), INTENT(OUT) :: tab_get
 
 ! Local variables
@@ -446,5 +434,5 @@
     ENDIF
     
-    DO i = 1, maxrecv
+    DO i = 1, maxrecv_phys
       IF (inforecv(i)%action .AND. inforecv(i)%nid .NE. -1) THEN
           field(:) = -99999.
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/output_physiqex_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/output_physiqex_mod.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/output_physiqex_mod.F90	(revision 4727)
@@ -0,0 +1,87 @@
+MODULE output_physiqex_mod
+
+
+
+CONTAINS 
+
+SUBROUTINE output_physiqex(debut,zjulian,pdtphys,presnivs,paprs,u,v,t,qx,cf,zqr,zqs,zqg,ptke,theta)
+
+      USE dimphy, only : klon,klev
+      USE iophy, only : histbeg_phy,histwrite_phy
+      USE ioipsl, only : histvert,histdef,histend,histsync
+      USE mod_phys_lmdz_para, only : jj_nb
+      USE ioipsl_getin_p_mod, ONLY : getin_p
+      USE mod_grid_phy_lmdz, ONLY: nbp_lon,nbp_lat
+      USE iophy, ONLY : init_iophy_new
+      USE geometry_mod, ONLY: latitude_deg, longitude_deg
+      USE infotrac_phy, only : nqtot
+
+
+
+implicit none
+logical, intent(in) :: debut
+real, intent(in) :: pdtphys,zjulian
+real,intent(in) :: presnivs(klev) ! pseudo-pressure (Pa) of mid-layers
+real,intent(in) :: u(klon,klev) ! eastward zonal wind (m/s)
+real,intent(in) :: v(klon,klev) ! northward meridional wind (m/s)
+real,intent(in) :: t(klon,klev) ! temperature (K)
+real,intent(in) :: theta(klon,klev) ! temperature (K)
+real,intent(in) :: paprs(klon,klev+1) ! interlayer pressure (Pa)
+real,intent(in) :: qx(klon,klev,nqtot) !tracers
+real,intent(in) :: cf(klon,klev) !cloud fraction
+real,intent(in) :: zqr(klon,klev) !rain specifiq content
+real,intent(in) :: zqs(klon,klev) !snow specifiq content
+real,intent(in) :: zqg(klon,klev) !graupel specifiq content
+real,intent(in) :: ptke(klon,klev) !tke
+
+real :: t_ops ! frequency of the IOIPSL operations (eg average over...)
+real :: t_wrt ! frequency of the IOIPSL outputs
+integer :: zvertid ! vertical coordinate ID
+real :: dtime
+
+integer,save :: iwrite_phys=1 ! output every iwrite_phys physics step
+!$OMP THREADPRIVATE(iwrite_phys)
+integer :: nhori ! horizontal coordinate ID
+integer,save :: nid_hist ! output file ID
+!$OMP THREADPRIVATE(nid_hist)
+integer, save :: itau=0
+!$OMP THREADPRIVATE(itau)
+
+integer, save :: ioex=1
+
+
+print*,'nnnnnnn ',nid_hist,debut,itau
+
+if(debut)then
+
+   call getin_p("iwrite_phys",iwrite_phys)
+
+   !$OMP MASTER
+   CALL iophys_ini(pdtphys)
+   !$OMP END MASTER
+   !$OMP BARRIER
+
+endif
+
+
+itau=itau+1
+
+if (modulo(itau,iwrite_phys)==0) then
+     call iophys_ecrit('temp',klev,'Temperature','K',t)
+     call iophys_ecrit('u',klev,'zonal wind','m/s',u)
+     call iophys_ecrit('v',klev,'meridinal wind','m/s',v)
+     call iophys_ecrit('ps',1,'Surface pressure','Pa',paprs(:,1))
+     call iophys_ecrit('qv',klev,'Water vapor specifiq content', 'kg/kg', qx(:,:,1))
+     call iophys_ecrit('qc',klev,'Cloud liquid water specifiq content', 'kg/kg', qx(:,:,2))
+     call iophys_ecrit('qi',klev,'Cloud solid water specifiq content', 'kg/kg', qx(:,:,3))
+     call iophys_ecrit('CF',klev,'Cloud fraction', '0-1', cf)
+     call iophys_ecrit('qr',klev,'Rain specifiq content', 'kg/kg', zqr)
+     call iophys_ecrit('qs',klev,'Snow specifiq content', 'kg/kg', zqs)
+     call iophys_ecrit('qg',klev,'Graupel specifiq content', 'kg/kg', zqg)
+     call iophys_ecrit('TKE',klev,'TKE', 'm2/s2', ptke)
+     call iophys_ecrit('theta',klev,'Temperature potentielle', 'K', theta)
+endif
+
+
+END SUBROUTINE output_physiqex
+END MODULE output_physiqex_mod
